#!/bin/sh

set -e

cd $(dirname $0)

. ../../../common/config.sh
. ../../../common/log.sh

log_start "$0" "grpck can check the group entries when there are no gshadow file"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config' 0

change_config

echo -n "Remove the gshadow file..."
rm -f /etc/gshadow
echo "done"

echo -n "Check the group entries (grpck -r)..."
grpck -r >tmp/grpck.out && exit 1 || {
        status=$?
}
echo "OK"

echo -n "Check returned status ($status)..."
test "$status" = "2"
echo "OK"

echo "grpck reported:"
echo "======================================================================="
cat tmp/grpck.out
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au data/grpck.out tmp/grpck.out
echo "error message OK."
rm -f tmp/grpck.out

echo -n "Check the passwd file..."
../../../common/compare_file.pl config/etc/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../../common/compare_file.pl config/etc/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../../common/compare_file.pl config/etc/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
test ! -f /etc/gshadow
echo "OK"

log_status "$0" "SUCCESS"
restore_config
trap '' 0